package com.funambol.util;
/*
 * Copyright (C) 2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

import com.funambol.util.*;
import com.tinyline.util.GZIPInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;

public class GzipStreamReader implements StreamReader {
    
    //---------------------------------------------------------------- Constants
    
    //------------------------------------------------------------- Private Data
    
    //--------------------------------------------------------------- Properties
    
    //------------------------------------------------------------- Constructors
    
    /**
     * Creates a new instance of GzipStreamReader
     */
    public GzipStreamReader() {
        
    }
    
    //----------------------------------------------------------- Public Methods
    
    //-----------------------------------------------------------Private Methods

    public byte[] readStream(InputStream in, int bufferSize) 
                                     throws IOException {
        if (bufferSize <= 0) {
            bufferSize = BUFFERSIZE;
        } 
        
        in = new GZIPInputStream(in);
           
        ByteArrayOutputStream bout = new ByteArrayOutputStream(bufferSize);

        byte[] buf = new byte[BUFFERSIZE];
        int n = 0;

        while ((n = in.read(buf)) >= 0) {
            bout.write(buf, 0, n);
        }
        buf=null;

        return bout.toByteArray();
    }
}
